

!include "MUI.nsh"

;--------------------------------
;General


  !define CompName "Test"
  !define VpnAddress "vpn.mydomain.com"
  
  Name "${CompName} SecureConnect" 

  !define ShortProgName "VPN ${CompName}"
  !define LongProgName "Kit de connexion ${CompName} SecureConnect"
  !define PAGE_TITLE "Installation du ${LongProgName}"
  ;!define PAGE_SUBTITLE "sous titre 2"

  OutFile "${CompName}SecurConnect.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\${ShortProgName}"

  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\$ShortProgName" ""


;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !define MUI_WELCOMEPAGE_TITLE "${LongProgName}"
  ;!define MUI_PAGE_HEADER_TEXT "text"
  !insertmacro MUI_PAGE_WELCOME  
  ;!insertmacro MUI_PAGE_LICENSE "${NSISDIR}\Docs\Modern UI\License.txt"
  
  ;!insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  Page custom ChooseCert ValidateCert
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

  !insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH

;--------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "French"

  ReserveFile "CertDlg.ini"
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

;--------------------------------
;Installer Sections

Section "Dummy Section" SecDummy
  ; fermeture de l'application
  Push "openvpn-gui-1.0.3-fr.exe"
  KillProcDLL::KillProc

  SetOutPath "$INSTDIR"

  File openvpn.exe
  File libeay32.dll
  File libssl32.dll
  File openvpn-gui-1.0.3-fr.exe
  File /r tap-win32-hiddentap 
  File /r log
  File /r config

  ;Store installation folder
  WriteRegStr HKCU "Software\${ShortProgName}" "" $INSTDIR
  SetShellVarContext current
  
  createShortCut "$SMSTARTUP\${ShortProgName}.lnk" "$INSTDIR\openvpn-gui-1.0.3-fr.exe"

  ; mise  jour de la base de registre
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI config_dir "$INSTDIR\config"
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI exe_path "$INSTDIR\openvpn.exe"
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI log_dir "$INSTDIR\log"
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI allow_edit "0"
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI allow_password "0"
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI allow_proxy "0"
  WriteRegStr HKLM  SOFTWARE\OpenVPN-GUI silent_connection "0"

  WriteRegStr HKLM  SOFTWARE\OpenVPN "config_dir" "$INSTDIR"

  WriteRegStr HKLM  SOFTWARE\OpenVPN "config_ext" "$INSTDIR"
  WriteRegStr HKLM  SOFTWARE\OpenVPN "exe_path" "$INSTDIR"
  WriteRegStr HKLM  SOFTWARE\OpenVPN "log_dir" "$INSTDIR\log"
  WriteRegStr HKLM  SOFTWARE\OpenVPN "priority" "0"
  WriteRegStr HKLM  SOFTWARE\OpenVPN "log_append" "0"
  WriteRegStr HKLM  SOFTWARE\OpenVPN "" "$INSTDIR"



  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${ShortProgName}" "DisplayName" "${LongProgName}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${ShortProgName}" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${ShortProgName}" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${ShortProgName}" "NoRepair" 1
  
  ; UNIXDIR
  var /GLOBAL UNIXDIR
  Push $INSTDIR 
  Push "\"
  Push "/"
  Call StrReplace
  Pop $0
  strcpy $UNIXDIR $0
  
  ; configuration du fichier client.ovpn
  Push "$INSTDIR\config\client.ovpn" ; file to modify
  Push "#@remote@" ; string that a line must begin with
  Push "remote ${VpnAddress} 1194" ; string to replace whole line with
  Call ReplaceLineStr
  
  Push "$INSTDIR\config\client.ovpn"
  Push "#@ca@"
  Push "ca $\"$UNIXDIR/config/ca.crt$\""
  Call ReplaceLineStr
  
  Push "$INSTDIR\config\client.ovpn"
  Push "#@cert@"
  Push "cert $\"$UNIXDIR/config/client.crt$\""
  Call ReplaceLineStr
  
  Push "$INSTDIR\config\client.ovpn"
  Push "#@key@"
  Push "key $\"$UNIXDIR/config/client.crt$\""
  Call ReplaceLineStr


	; installation VPN et renommage de la carte virtuelle
  ReadRegStr $0 HKLM SYSTEM\CurrentControlSet\Enum\Root\NET\0000 "Mfg"
  StrCmp $1 "TAP-Win32 Provider" After.install
  SetOutPath "$INSTDIR\tap-win32-hiddentap"
  IfErrors 0 After.install
  nsExec::ExecToLog 'tapinstall.exe install OemWin2khid.inf tap0801'
  
  StrCpy $0 0
  loopInstall:
  EnumRegKey $1 HKLM "SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}" $0
  StrCmp $1 "" After.install
  ReadRegStr $2 HKLM SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}\$1 Manufacturer
  StrCmp $2 "TAP-Win32 Provider" 0 +3
  ReadRegStr $3 HKLM SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}\$1 NetCfgInstanceId
  WriteRegStr HKLM  SYSTEM\CurrentControlSet\Control\Network\{4D36E972-E325-11CE-BFC1-08002BE10318}\$3\Connection "Name" "Connexion VPN"
  WriteRegStr HKLM  SYSTEM\CurrentControlSet\Control\Network\{4D36E972-E325-11CE-BFC1-08002BE10318}\$3\Connection "PnpInstanceID" "ROOT\NET\0000"
  IntOp $0 $0 + 1
  goto loopInstall
  
  After.install:

SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecDummy ${LANG_ENGLISH} "A test section."

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecDummy} $(DESC_SecDummy)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"
  ; fermeture de l'application
  Push "openvpn-gui-1.0.3-fr.exe"
  KillProcDLL::KillProc

  SetOutPath "$INSTDIR\tap-win32-hiddentap"
  nsExec::ExecToLog 'tapinstall.exe remove tap0801'
  
  StrCpy $0 0
  loopUninstall:
  EnumRegKey $1 HKLM "SYSTEM\CurrentControlSet\Control\Network\{4D36E972-E325-11CE-BFC1-08002BE10318}" $0
  StrCmp $1 "" After.Uninstall
  ReadRegStr $2 HKLM SYSTEM\CurrentControlSet\Control\Network\{4D36E972-E325-11CE-BFC1-08002BE10318}\$1\Connection PnpInstanceID
  StrCmp $2 "ROOT\NET\0000" 0 +2
  DeleteRegKey HKLM SYSTEM\CurrentControlSet\Control\Network\{4D36E972-E325-11CE-BFC1-08002BE10318}\$1 
  IntOp $0 $0 + 1
  goto loopUninstall
  
After.Uninstall:
  SetShellVarContext current
  Delete "$SMSTARTUP\${ShortProgName}.lnk"
  Delete "$INSTDIR\Uninstall.exe"
  SetOutPath "$TEMP"
  RMDir /r "$INSTDIR"

  DeleteRegKey /ifempty HKCU "Software\${ShortProgName}"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${ShortProgName}"
  
SectionEnd

Function .onInit

  ;Extract InstallOptions INI files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "CertDlg.ini"
FunctionEnd

Function ChooseCert
  !insertmacro MUI_HEADER_TEXT "${PAGE_TITLE}" "Installation du certificat personnel d'identification"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "CertDlg.ini"
FunctionEnd

Function ValidateCert
  !insertmacro INSTALLOPTIONS_READ $R0 "CertDlg.ini" "Field 2" "State"
  StrCmp $R0 "" 0 +3
  MessageBox MB_ICONEXCLAMATION|MB_OK "Vous devez slectionner un fichier d'identification numrique pour pouvoir continuer"
  Abort
  CopyFiles "$R0" "$R0.tmp"
  CreateDirectory "$INSTDIR\config"
  Rename "$R0.tmp" "$INSTDIR\config\client.crt"
FunctionEnd

; http://nsis.sourceforge.net/Replace_line_that_starts_with_specified_string
Function ReplaceLineStr
  Exch $R0 ; string to replace that whole line with
  Exch
  Exch $R1 ; string that line should start with
  Exch
  Exch 2
  Exch $R2 ; file
  Push $R3 ; file handle
  Push $R4 ; temp file
  Push $R5 ; temp file handle
  Push $R6 ; global
  Push $R7 ; input string length
  Push $R8 ; line string length
  Push $R9 ; global
  
  StrLen $R7 $R1
  
  GetTempFileName $R4
  
  FileOpen $R5 $R4 w
  FileOpen $R3 $R2 r
  
  ReadLoop:
  ClearErrors
  FileRead $R3 $R6
  IfErrors Done
  
  StrLen $R8 $R6
  StrCpy $R9 $R6 $R7 -$R8
  StrCmp $R9 $R1 0 +3
  
  FileWrite $R5 "$R0$\r$\n"
  Goto ReadLoop

  FileWrite $R5 $R6
  Goto ReadLoop
  
  Done:
  
  FileClose $R3
  FileClose $R5
  
  SetDetailsPrint none
  Delete $R2
  Rename $R4 $R2
  SetDetailsPrint both
  
  Pop $R9
  Pop $R8
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Pop $R1
  Pop $R0
FunctionEnd

; StrReplace
; Replaces all ocurrences of a given needle within a haystack with another string
; Written by dandaman32
; http://nsis.sourceforge.net/StrRep
Var STR_REPLACE_VAR_0
Var STR_REPLACE_VAR_1
Var STR_REPLACE_VAR_2
Var STR_REPLACE_VAR_3
Var STR_REPLACE_VAR_4
Var STR_REPLACE_VAR_5
Var STR_REPLACE_VAR_6
Var STR_REPLACE_VAR_7
Var STR_REPLACE_VAR_8
Function StrReplace
  Exch $STR_REPLACE_VAR_2
  Exch 1
  Exch $STR_REPLACE_VAR_1
  Exch 2
  Exch $STR_REPLACE_VAR_0
    StrCpy $STR_REPLACE_VAR_3 -1
    StrLen $STR_REPLACE_VAR_4 $STR_REPLACE_VAR_1
    StrLen $STR_REPLACE_VAR_6 $STR_REPLACE_VAR_0
    loop:
      IntOp $STR_REPLACE_VAR_3 $STR_REPLACE_VAR_3 + 1
      StrCpy $STR_REPLACE_VAR_5 $STR_REPLACE_VAR_0 $STR_REPLACE_VAR_4 $STR_REPLACE_VAR_3
      StrCmp $STR_REPLACE_VAR_5 $STR_REPLACE_VAR_1 found
      StrCmp $STR_REPLACE_VAR_3 $STR_REPLACE_VAR_6 done
      Goto loop
    found:
      StrCpy $STR_REPLACE_VAR_5 $STR_REPLACE_VAR_0 $STR_REPLACE_VAR_3
      IntOp $STR_REPLACE_VAR_8 $STR_REPLACE_VAR_3 + $STR_REPLACE_VAR_4
      StrCpy $STR_REPLACE_VAR_7 $STR_REPLACE_VAR_0 "" $STR_REPLACE_VAR_8
      StrCpy $STR_REPLACE_VAR_0 $STR_REPLACE_VAR_5$STR_REPLACE_VAR_2$STR_REPLACE_VAR_7
      StrLen $STR_REPLACE_VAR_6 $STR_REPLACE_VAR_0
      Goto loop
    done:
  Pop $STR_REPLACE_VAR_1 ; Prevent "invalid opcode" errors and keep the
  Pop $STR_REPLACE_VAR_1 ; stack as it was before the function was called
  Exch $STR_REPLACE_VAR_0
FunctionEnd